Code written by Russlan Jaafreh
#Libraries needed to run the code: [Pandas, numpy, seaborn, matplotlib, sklearn, ALEPython, imblearn] all of them are used in their latest editions

#Importing the data
import pandas as pd
import numpy as np
df_text = pd.read_excel("Data for Learning Process.xlsx",engine="openpyxl") #make sure to include the file in the directory of the code
df_text = df_text.dropna()
X = df_text.drop(['ID','KAM',"Class"], axis ='columns')
Y = df_text['Class']
Y.describe()

#Resampling the  data using imblearn
from imblearn.over_sampling import RandomOverSampler
from imblearn.combine import SMOTETomek
from imblearn.over_sampling import SMOTE, ADASYN

#depending on what is needed, choose the resampling technique for replication, here i am going to only use the SMOTE-Tomek

sm  =SMOTETomek(random_state=0)
X_resampled, y_resampled = sm.fit_resample(X,Y)

#Classification using ONLY ERT
from sklearn.ensemble import RandomForestClassifier
from sklearn.metrics import accuracy_score
from sklearn.metrics import roc_curve
from sklearn.metrics import auc
from sklearn.metrics import classification_report
from sklearn import metrics
from sklearn.ensemble import ExtraTreesClassifier


X_train,X_test,y_train,y_test = train_test_split(X_resampled,y_resampled,test_size =0.20, random_state = 7)
re_class = ExtraTreesClassifier(n_estimators=500,criterion='gini')
re_class.fit(X_train,y_train)
accuracy_score(y_test,re_class.predict(X_test))
print(classification_report(y_test, re_class.predict(X_test)))

#Confusion matrix
from sklearn.metrics import confusion_matrix
tn, fp, fn, tp = confusion_matrix(y_test,re_class.predict(X_test)).ravel()
(tn, fp, fn, tp)

#10 k-fold CV
from sklearn.model_selection import cross_val_score
scores = cross_val_score(re_class, X_resampled, y_resampled, cv=10, scoring='balanced_accuracy')
scores2 = cross_val_score(re_class, X_resampled, y_resampled, cv=10, scoring='f1_macro')
sum_acc = sum(scores)/10
sum_f1 = sum(scores2)/10

#Feature importance using Gini impurity of ERT
from matplotlib import pyplot
importance = re_class.feature_importances_

#Plot feature importance
pyplot.bar([x for x in range(len(importance))], importance)
pyplot.show()

#Listing gini impurity and feature name
data = pd.DataFrame({'x' : X.columns, 'y' : importance})






